﻿/*
coded by Kristin Henry 
galaxygoo@gmail.com
www.underground-flash.com
www.underground-lab.com

This code is available as is, without warranty.
*/

package{
	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	
	
	public class Jelly extends Sprite{
		// Properties
		//----------------------------------------
		private var s:Number = 1;  	// speed
				
		private var color1 = 0x999999; 
		private var alph = .4;
		
		public var vx = .1;
		public var vy = .1;		
		public var xy:Array;		// xy coordinates on stage
			
		public var dots:Array = new Array();
		
					
		// Constructor
		//----------------------------------------
		public function Jelly(){
												
			setXY();
			setPoints();
			drawBubble();
			drawLines();
			drawOutline();
		}
		
		// Methods
		//----------------------------------------		
		public function setXY(){
			this.x = Math.random() * 400 + 70;
			this.y = Math.random() * 260 + 60;
		}
		
		// position dots
		function setPoints(){
		
			var i_max = 12;
	
			for(var i=0; i<i_max; i++){
		
				var d = new Dot();
		
				var mult = .3;
		
				var deg = (360/i_max)*i;
				var r = 30;
				var origin = 0;
				d.x = r * Math.cos(deg * Math.PI/180) + origin;
				d.y = mult* r * Math.sin(deg * Math.PI/180) + origin;
		
				d.alpha = .6;
						
				dots.push(d);
				this.addChild(d);
				
			}
		}
		
		function drawBubble():void
		{
			gradientBubble();
			fullBubble();
			backOfBubble();	
		}
		
		function backOfBubble(){
			
			var b2 = new Sprite();
			b2.graphics.beginFill(color1, alph);
			b2.graphics.moveTo(dots[0].x, dots[0].y);
			
			for(var i = 11; i>=7 ; i--){
				b2.graphics.lineTo(dots[i].x, dots[i].y);
			}
			
			b2.graphics.curveTo(dots[0].x - 30, dots[0].y - 50, dots[0].x, dots[0].y);
			b2.graphics.endFill();
			
			this.addChild(b2);
		}
		
		function fullBubble(){
						
			var b1 = new Sprite();
			b1.graphics.beginFill(color1, alph);
			b1.graphics.moveTo(dots[0].x, dots[0].y);
			
			for(var i = 0; i<=6 ; i++){
				b1.graphics.lineTo(dots[i].x, dots[i].y);
			}
			
			b1.graphics.curveTo(dots[0].x - 30, dots[0].y - 50, dots[0].x, dots[0].y);
			b1.graphics.endFill();
			
			this.addChild(b1);
		}
		
		function gradientBubble(){
			
			var b3 = new Sprite();
				
   			var fillType = "radial"
   		 	var colors = [0xFF0000, 0x0000FF];
			var alphas = [.4, .4];
    		var ratios = [10, 200];
		    var spreadMethod = "reflect";
		    var interpolationMethod = "RGB";
		    var focalPointRatio = 0.1;
		    var matrix = new Matrix();
		    matrix.createGradientBox(100, 100, 0, 0, 0);
		    
			b3.graphics.beginGradientFill(fillType, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio);
			
			b3.graphics.moveTo(dots[0].x, dots[0].y);
			
			for(var i = 0; i<=6 ; i++){
					b3.graphics.lineTo(dots[i].x, dots[i].y);
			}
			
			b3.graphics.curveTo(dots[0].x - 30, dots[0].y - 50, dots[0].x, dots[0].y);
			b3.graphics.endFill();
			
			this.addChild(b3);
		}
		
		function drawLines():void
		{
			for(var i = 0; i<dots.length; i++){
						
				var line = new Sprite();
				line.x = dots[i].x;
				line.y = dots[i].y;
				
				drawWave(line);
				
				this.addChild(line);
			}
		}

		function drawWave(targ){
	
			// determine, randomly, if curve starts to right or left
			var s = Math.floor(Math.random() * 2 + 1);
			if(s == 2){
				sign = -1;
			} else if(s == 1){
				sign = 1;
			}
	
			// control point for curve
			var ranNum = randRange(90, 180)*sign;
			var ranNum2 = randRange(2, 6);
		
			var controlX1 = Math.sin(ranNum)*ranNum2;
			var controlY1 = 20;
			var anchorX1 = 0;
			var anchorY1 = 30;

			var controlX2 = -Math.sin(ranNum)*ranNum2;
			var controlY2 = 40;
			var anchorX2 = 0;
			var anchorY2 = 50;
	
			targ.graphics.lineStyle(1, color1, alph);
			targ.graphics.moveTo(0,0);

			targ.graphics.curveTo(controlX1, controlY1, anchorX1, anchorY1);
			targ.graphics.curveTo(controlX2, controlY2, anchorX2, anchorY2);
	
		}

		function drawOutline():void{
	
			// draw connecting lines  
			var circ = new Sprite();
			circ.graphics.lineStyle(1, color1, alph);
	
			circ.graphics.moveTo(dots[0].x, dots[0].y);
			
			for(var i=1; i<dots.length; i++){
				circ.graphics.lineTo(dots[i].x, dots[i].y);
			}
			
			this.addChild(circ);
		}

		function randRange(min:Number, max:Number):Number {
    		var randomNum:Number = Math.floor(Math.random() * (max - min + 1)) + min;
    		return randomNum;
		}
				
				
	}
}