﻿/*
coded by Kristin Henry 
galaxygoo@gmail.com
www.underground-flash.com
www.underground-lab.com

This code is available as is, without warranty.
*/

package{
	
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	
	
	public class LightUp {
		
		// Properties
		//----------------------------------------
		private var jellies:Array;
		private var timer1:Timer;
		private var timer2:Timer;
		
		private var jelly:Jelly;
		private var dot = 0;
		
		
		
		// Constructor
		//----------------------------------------
		public function LightUp(jellyArray):void{
			
			jellies = jellyArray;
			LightJellies();
						
		}
		
		// Methods
		//----------------------------------------		
		public function LightJellies():void{
			timer1 = new Timer(1600, 0);
			timer1.addEventListener(TimerEvent.TIMER, lightJelly);
			timer1.start();
		}
		
		public function lightJelly(event:TimerEvent):void{
			
			//select random jelly to light up
			var max = jellies.length - 1;
			var i = randRange(0, max);
			// remember which jelly we're lighting up this time
			jelly = jellies[i];
			
			// generate bioluminescence effect on this jelly
			lightDots();
			resetDots();
		}
		
		private function lightDots():void{			
			timer2 = new Timer(60, 0);
			timer2.addEventListener(TimerEvent.TIMER, lightDot);
			timer2.start();
		}
		
		private function lightDot(event:TimerEvent):void{
			if(dot >= 12){
				// restore last dot, reset counter, and stop effect
				jelly.dots[dot -1].alpha = .5;
				dot = 0;
				timer2.stop();
			} else if(dot == 0){
				// start at first dot & light it up
				jelly.dots[dot].alpha = 1;
				dot++;
			} else{
				// restore last dot
				jelly.dots[dot - 1].alpha = .5;
				//brighten this dot
				jelly.dots[dot].alpha = 1;
				// increment array index
				dot++;
			}
		}
		
		private function resetDots():void{
			// make sure all dots restrored to default alpha		
			var max = jelly.dots.length;
			for(var i = 0; i < max; i++){
				jelly.dots[i].alpha = .5;
			}
		}
		
		function randRange(min:Number, max:Number):Number {
    		var randomNum:Number = Math.floor(Math.random() * (max - min + 1)) + min;
    		return randomNum;
		}
		
	}
	
}